head	1.4;
access;
symbols;
locks;
comment	@ * @;


1.4
date	93.05.06.10.08.20;	author karn;	state Exp;
branches;
next	1.3;

1.3
date	93.03.25.09.38.27;	author karn;	state Exp;
branches;
next	1.2;

1.2
date	93.02.23.04.16.30;	author karn;	state Exp;
branches;
next	1.1;

1.1
date	93.02.22.00.52.09;	author karn;	state Exp;
branches;
next	;


desc
@Fax over CDMA demo - initial version
@


1.4
log
@Change int16 to uint16
Remove __ARGS(()) construct
@
text
@#include <stdio.h>
#include "socket.h"
#include "telnet.h"
#include "netuser.h"
#include "iface.h"
#include "devparam.h"
#include "n8250.h"
#include "asy.h"

static void logrx(int,void *,void *);
static int keychar(int c);
void qfax2_main( int i1, void *p1, void *p2 );

int Nfax;
extern struct proc * Remote_fm_task_ptr;
extern struct proc * Local_fm_task_ptr;
extern unsigned char *Pds_buffer; /* DSP and MSG made this. */

int
dofax(argc,argv,p)
int argc;
char *argv[];
void *p;
{
	FILE *remote;
	int s;
	struct sockaddr_in msock;
	struct session *sp;
	int c;
	FILE *asy;

	if(Nfax != 0){
		printf("Fax already active\n");
		return 1;
	}
	if(SETSIG(EABORT)){
		/* Restore serial port packet driver */
		goto done;
	}
	Nfax++;
	sp = newsession("fax",FAX,1);
	setvbuf(stdout,NULLCHAR,_IOLBF,BUFSIZ);

	sp->inproc = keychar;   /* Intercept ^C */
	if((asy = asyopen(argv[3],"r+b")) == NULLFILE){
		printf("Can't open asy port %s\n",argv[3]);
		goto done;
	}
	msock.sin_family = AF_INET;
	msock.sin_port = atoi(argv[2]);
	printf("Resolving %s\n",argv[1]);
	msock.sin_addr.s_addr = resolve(argv[1]);

	s = socket(AF_INET,SOCK_STREAM,0);
	if(connect(s,(char *)&msock,sizeof(msock)) == -1){
		perror("connect failed");
		goto done;
	}
	sp->network = remote = fdopen(s,"r+b");
	setvbuf(remote,NULLCHAR,_IOFBF,BUFSIZ);
	/* Spawn off receiver task */
	printf("Connected to modem server. Log in manually, hit ESC<cr> when done\n");
	sp->proc1 = newproc("login rx",512,logrx,0,(void *)remote,(void *)sp,0);
	while((c = getc(stdin)) != '\033' && c != EOF){
		putc(c,remote);
		fflush(remote);
	}
	killproc(sp->proc1);
	sp->proc1 = NULLPROC;
	printf("Starting fax...\n");
	qfax2_main(0,(void *)remote,(void *)asy);
done:
/*if 0 */
	killproc(Remote_fm_task_ptr);
	Remote_fm_task_ptr = NULLPROC;
	killproc(Local_fm_task_ptr);
	Local_fm_task_ptr = NULLPROC;
	if(Pds_buffer)
		free(Pds_buffer);
	Pds_buffer = NULL;
/*endif*/
	Nfax = 0;
	fclose(asy);
	keywait(NULLCHAR,1);
	freesession(sp);
	return 0;
}
static void
logrx(i,p1,p2)
int i;
void *p1,*p2;
{
	FILE *remote = (FILE *)p1;
	struct session *sp = (struct session *)p2;
	int c;

	while((c = fgetc(remote)) != EOF){
		if(c != IAC){
			putchar(c);
			continue;
		}
		c = fgetc(remote);
		switch(c){
		case WILL:
			c = fgetc(remote);
			switch(c){
			case TN_ECHO:
			case TN_SUPPRESS_GA:
				fprintf(remote,"%c%c%c",IAC,DO,c);
			}
			break;
		case WONT:
			c = fgetc(remote);
			break;
		case DO:
			c = fgetc(remote);
			fprintf(remote,"%c%c%c",IAC,WONT,c);
			break;
		case DONT:
			c = fgetc(remote);
			break;
		}
	}
	printf("connection closed by remote host\n");
	sp->proc1 = NULLPROC;
}
static int
keychar(c)
int c;
{
	if(c != CTLC)
		return 1;       /* Ignore all but ^C */

	fprintf(Current->output,"^C\n");
	alert(Current->proc,EABORT);
	return 0;
}
/* Start up the fax server */
#define	IPPORT_FAX	5001
static void faxserv(int,void *,void *);

int
fax1(argc,argv,p)
int argc;
char *argv[];
void *p;
{
	uint16 port;

	if(argc < 2)
		port = IPPORT_FAX;
	else
		port = atoi(argv[1]);
	return start_tcp(port,"Fax Server",faxserv,576);
}
static void
faxserv(s,unused,p)
int s;
void *unused;
void *p;
{
	FILE *network = NULLFILE;
	char *buf = NULLCHAR;
	FILE *asy;
	
	sockowner(s,Curproc);
	log(s,"open fax");
	network = fdopen(s,"r+");

	if(network == NULLFILE || (buf = malloc(BUFSIZ)) == NULLCHAR)
		goto quit;

	if(SETSIG(EABORT)){
		fprintf(network,"Abort\r\n");
		goto quit;
	}
	for(;;){
		fprintf(network,"Enter a line: ");
		fflush(network);
		if(fgets(buf,BUFSIZ,network) == NULL)
			break;
		fprintf(network,"The line you entered: %s\n",buf);
	}
quit:	fclose(network);
	log(s,"close fax");
	free(buf);
	close_s(s);
}

/* Stop fax server */
int
fax0(argc,argv,p)
int argc;
char *argv[];
void *p;
{
	uint16 port;

	if(argc < 2)
		port = IPPORT_FAX;
	else
		port = atoi(argv[1]);
	return stop_tcp(port);
}

@


1.3
log
@*** empty log message ***
@
text
@d10 2
a11 2
static void logrx __ARGS((int,void *,void *));
static int keychar __ARGS((int c));
d140 1
a140 1
static void faxserv __ARGS((int,void *,void *));
d148 1
a148 1
	int16 port;
d197 1
a197 1
	int16 port;
@


1.2
log
@minor changes - free Dave's big malloc'ed buffer
@
text
@d7 2
d15 3
d30 2
a31 5
	struct iface *ifp;
	int dev;
	char *dialnum;
	
	setvbuf(stdout,NULLCHAR,_IOLBF,0);
d36 4
d42 6
a47 8
	sp->inproc = keychar;	/* Intercept ^C */
	dialnum = strdup(argv[4]);
	if((ifp = if_lookup(argv[3])) == NULLIF){
		printf("Interface %s unknown\n",argv[3]);
		keywait(NULLCHAR,1);
		freesession(sp);
		Nfax = 0;
		return 1;
a48 8
	if(SETSIG(EABORT)){
		keywait(NULLCHAR,1);
		freesession(sp);
		Nfax = 0;
		return 1;
	}

	dev = ifp->dev;
d57 1
a57 4
		keywait(NULLCHAR,1);
		freesession(sp);
		Nfax = 0;
		return 1;
d60 1
a60 1
	setvbuf(remote,NULLCHAR,_IONBF,0);
d64 1
a64 1
	while((c = getc(stdin)) != '\033' && c != EOF)
d66 2
d71 11
a81 2
	qfax2_main(dev,(void *)remote,(void *)dialnum);
	free(dialnum);
d83 1
a130 2
	extern char *Pds_buffer;

d132 1
a132 1
		return 1;	/* Ignore all but ^C */
a135 3
	if(Pds_buffer)
		free(Pds_buffer);
	Pds_buffer = NULL;
d138 68
@


1.1
log
@Initial revision
@
text
@d126 2
d133 3
@
