head	1.10;
access;
symbols;
locks;
comment	@ * @;


1.10
date	92.10.07.19.29.30;	author karn;	state Exp;
branches;
next	1.9;

1.9
date	92.05.03.03.26.38;	author karn;	state Exp;
branches;
next	1.8;

1.8
date	92.05.01.08.21.48;	author karn;	state Exp;
branches;
next	1.7;

1.7
date	92.04.30.20.04.02;	author karn;	state Exp;
branches;
next	1.6;

1.6
date	92.04.08.08.28.44;	author karn;	state Exp;
branches;
next	1.5;

1.5
date	92.04.06.11.51.56;	author karn;	state Exp;
branches;
next	1.4;

1.4
date	91.05.13.16.59.54;	author karn;	state Exp;
branches;
next	1.3;

1.3
date	91.03.17.10.30.42;	author karn;	state Exp;
branches;
next	1.2;

1.2
date	91.02.21.13.35.14;	author karn;	state Exp;
branches;
next	1.1;

1.1
date	91.01.27.11.59.04;	author karn;	state Exp;
branches;
next	;


desc
@src0201
@


1.10
log
@Eliminate obsolete vj arg to kiss_init def, remove setencap call
@
text
@/* Routines for AX.25 encapsulation in KISS TNC
 * Copyright 1991 Phil Karn, KA9Q
 */
#include "global.h"
#include "mbuf.h"
#include "iface.h"
#include "kiss.h"
#include "devparam.h"
#include "slip.h"
#include "asy.h"
#include "ax25.h"
#include "pktdrvr.h"

/* Set up a SLIP link to use AX.25 */
int
kiss_init(ifp)
struct iface *ifp;
{
	int xdev;
	struct slip *sp;
	char *ifn;

	for(xdev = 0;xdev < SLIP_MAX;xdev++){
		sp = &Slip[xdev];
		if(sp->iface == NULLIF)
			break;
	}
	if(xdev >= SLIP_MAX) {
		printf("Too many slip devices\n");
		return -1;
	}
	ifp->ioctl = kiss_ioctl;
	ifp->raw = kiss_raw;
	ifp->show = slip_status;

	if(ifp->hwaddr == NULLCHAR)
		ifp->hwaddr = mallocw(AXALEN);
	memcpy(ifp->hwaddr,Mycall,AXALEN);
	ifp->xdev = xdev;

	sp->iface = ifp;
	sp->send = asy_send;
	sp->get = get_asy;
	sp->type = CL_KISS;
	ifp->rxproc = newproc( ifn = if_name( ifp, " rx" ),
		256,slip_rx,xdev,NULL,NULL,0);
	free(ifn);
	return 0;
}
int
kiss_free(ifp)
struct iface *ifp;
{
	if(Slip[ifp->xdev].iface == ifp)
		Slip[ifp->xdev].iface = NULLIF;
	return 0;
}
/* Send raw data packet on KISS TNC */
int
kiss_raw(iface,bp)
struct iface *iface;
struct mbuf *bp;
{
	/* Put type field for KISS TNC on front */
	bp = pushdown(bp,1);
	bp->data[0] = PARAM_DATA;
	/* slip_raw also increments sndrawcnt */
	slip_raw(iface,bp);
	return 0;
}

/* Process incoming KISS TNC frame */
void
kiss_recv(iface,bp)
struct iface *iface;
struct mbuf *bp;
{
	char kisstype;

	kisstype = PULLCHAR(&bp);
	switch(kisstype & 0xf){
	case PARAM_DATA:
		ax_recv(iface,bp);
		break;
	default:
		free_p(bp);
		break;
	}
}
/* Perform device control on KISS TNC by sending control messages */
int32
kiss_ioctl(iface,cmd,set,val)
struct iface *iface;
int cmd;
int set;
int32 val;
{
	struct mbuf *hbp;
	char *cp;
	int rval = 0;

	/* At present, only certain parameters are supported by
	 * stock KISS TNCs. As additional params are implemented,
	 * this will have to be edited
	 */
	switch(cmd){
	case PARAM_RETURN:
		set = 1;	/* Note fall-thru */
	case PARAM_TXDELAY:
	case PARAM_PERSIST:
	case PARAM_SLOTTIME:
	case PARAM_TXTAIL:
	case PARAM_FULLDUP:
	case PARAM_HW:
		if(!set){
			rval = -1;	/* Can't read back */
			break;
		}
		/* Allocate space for cmd and arg */
		if((hbp = alloc_mbuf(2)) == NULLBUF){
			free_p(hbp);
			rval = -1;
			break;
		}
		cp = hbp->data;
		*cp++ = cmd;
		*cp = val;
		hbp->cnt = 2;
		slip_raw(iface,hbp);	/* Even more "raw" than kiss_raw */
		rval = val;		/* per Jay Maynard -- mce */
		break;
	case PARAM_SPEED:	/* These go to the local asy driver */
	case PARAM_DTR:
	case PARAM_RTS:
		rval = asy_ioctl(iface,cmd,set,val);
		break;
	default:		/* Not implemented */
		rval = -1;
		break;
	}
	return rval;
}
@


1.9
log
@src0503
@
text
@d16 1
a16 1
kiss_init(ifp,vj)
a17 1
int vj;	/* Unused */
a31 1
	setencap(ifp,"KISS");
@


1.8
log
@src0501
@
text
@d48 1
a48 1
		256,asy_rx,xdev,NULL,NULL,0);
@


1.7
log
@src0429
@
text
@d30 1
a30 1
		tprintf("Too many slip devices\n");
@


1.6
log
@src0410
@
text
@d33 1
a33 1
	setencap(ifp,"AX25");
@


1.5
log
@src0406
@
text
@d62 1
a62 1
kiss_raw(iface,data)
d64 1
a64 1
struct mbuf *data;
a65 2
	register struct mbuf *bp;

d67 1
a67 4
	if((bp = pushdown(data,1)) == NULLBUF){
		free_p(data);
		return -1;
	}
@


1.4
log
@src0531
@
text
@d12 1
d14 46
@


1.3
log
@src0318
@
text
@d90 1
@


1.2
log
@src0221
@
text
@d94 1
a94 1
		rval = asy_ioctl(iface,val,set,val);
@


1.1
log
@Initial revision
@
text
@d8 1
d10 1
d26 1
a26 1
	bp->data[0] = KISS_DATA;
d42 1
a42 1
	case KISS_DATA:
d51 2
a52 2
int
kiss_ioctl(iface,argc,argv)
d54 3
a56 2
int argc;
char *argv[];
a58 1
	int i;
d60 1
d62 37
a98 3
	if(argc < 1){
		tprintf("Data field missing\n");
		return 1;
d100 1
a100 12
	/* Allocate space for arg bytes */
	if((hbp = alloc_mbuf((int16)argc)) == NULLBUF){
		free_p(hbp);
		return 0;
	}
	hbp->cnt = argc;
	hbp->next = NULLBUF;
	for(i=0,cp = hbp->data;i < argc;)
		*cp++ = atoi(argv[i++]);

	slip_raw(iface,hbp);	/* Even more "raw" than kiss_raw */
	return 0;
@
